<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Controllers\Providers\IAM\Core\AuthManager;
use App\Http\Models\PermintaanbarangModel;
use App\Http\Models\StgpelniprintModel;
use App\Http\Models\SyncUtilities\SyncHandlersModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;


class PermintaanbarangService extends BaseService
{
	/**
     PermintaanbarangService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new PermintaanbarangModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->joinRelationVoyageKode()->getQuery()
			->select([
				"permintaanbarang.id as id",
				"permintaanbarang.prNumber as prNumber",
				"permintaanbarang.isApproved as isApproved",
				"permintaanbarang.totalBarang as totalBarang",
				"permintaanbarang.tglPermintaan as tglPermintaan",
				"permintaanbarang.voyageKode as voyageKode",
				"permintaanbarang.voyageStart as voyageStart",
				"permintaanbarang.voyageEnd as voyageEnd",
				"voyageKode.voyageName as voyageName"
			]);
		// ->whereIn("permintaanbarang.locationId", $auth->arrLokasi);

		$input = $request->all();
		if (isset($input["q"])) {
			$arrKeys = explode("||", $input["q"]);
			foreach ($arrKeys as $key) {
				$arrKey = explode(":", $key);
				if (isset($arrKey[0]) && $arrKey[1] && $arrKey[0] == "namaItem" && !empty($arrKey[0])) {
					$namaItem = $arrKey[1];
					$this->model->getQuery()->whereIn('permintaanbarang.prNumber', function ($query) use ($namaItem) {
						$query->select('prNumber')->from('itempermintaanbarang')
							->join("item", "item.id", "=", "itempermintaanbarang.itemId")
							->where("item.namaItem", "ILIKE", "%" . $namaItem . "%")
							->orWhere("item.part_number", "ILIKE", "%" . $namaItem . "%")
							->orWhere("item.deskripsi", "ILIKE", "%" . $namaItem . "%");
					});
				}
			}
		}
//edited eko
		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("permintaanbarang.kapalId", "=", $auth->kapalId);


			$this->model->getQuery()->whereIn("permintaanbarang.prNumber", function ($query) use ($auth) {
				$query->select('itempermintaanbarang_.prNumber')
					->from('itempermintaanbarang_')
					->join("item", function ($join) {
						$join->on("item.id", "=", "itempermintaanbarang_.itemId");
						$join->on("item.kapalId", "=", "permintaanbarang.kapalId");
					})
					->whereIn("item.type_id", $auth->arrCategory);
			});
		}

		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("permintaanbarang.date_updated", "desc");
		}

		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return PermintaanbarangModel
	 */
	public function show($id)
	{
		$model = $this->model->joinRelationKapalId()->joinRelationVoyageKode()->joinRelationRequesterId()
			->getQuery()
			->where("permintaanbarang.id", "=", $id)->select([
				"permintaanbarang.*",
				"requesterId.name as requesterName",
				"requesterId.username as requesterUsername",
				"requesterId.jabatan as requesterJabatan",
				"voyageKode.voyageName as voyageName",
				"kapalId.namaKapal"
			])->first();
		return $model;
	}

	public function showByTransactionNo($prNumber)
	{
		$model = $this->model->joinRelationVoyageKode()->joinRelationRequesterId()->joinRelationKapalId()
			->getQuery()
			->where("permintaanbarang.prNumber", "=", $prNumber)->select([
				"permintaanbarang.*",
				"requesterId.name as requesterName",
				"requesterId.username as requesterUsername",
				"requesterId.jabatan as requesterJabatan",
				"voyageKode.voyageName as voyageName",
				"kapalId.namaKapal"
			])->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return PermintaanbarangModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$totalHarga = $totalBarang = 0;
		if (isset($input["itemID"])) {
			$totalBarang = array_sum($input["quantity"]);
		}
		$input["approverId"] = 0;
		$input["destinationType"] = "";
		$input["totalHarga"] = 0;
		$input["totalBarang"] = $totalBarang;

		$transactionBrg = new PermintaanbarangModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}



	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return PermintaanbarangModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$permintaanbarang = PermintaanbarangModel::find($id);
		$permintaanbarang->fill($input);
		if (!$permintaanbarang->update()) {
			throw new \Exception();
		}
		return $permintaanbarang;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}


	// private function getPRNumber()
	// {
	// 	return "PELNI/PR " . date("y") . " " .  " " . $this->getLastestID();
	// }

	public function getLastestID($prefix)
	{
		$getMaxID = $this->model->getQuery()->selectRaw('MAX( SUBSTRING( "permintaanbarang"."prNumber", 9, 6 ) ) AS "prNumber"')->where("permintaanbarang.prNumber", "ILIKE", $prefix . "%")->first();

		if ($getMaxID->prNumber) {
			// var_dump($getMaxID); echo $prefix . substr("000000" . (intval($getMaxID->prNumber) + 1), -6); dd();
			return $prefix . substr("000000" . (intval($getMaxID->prNumber) + 1), -6);
		} else {
			// var_dump($getMaxID); echo "2"; dd();
			return $prefix . "000001";
		}
	}

	public function approve($input)
	{
		$dateTimeApproved = date("Y-m-d H:i:s");
		$newInput = [
			"approverId" => $input["approverId"],
			"feedback" => $input["feedback"],
			"tglApproved" => $dateTimeApproved,
			"date_updated" => $dateTimeApproved,
			"isApproved" => $input["isApproved"]
		];
		$permintaanbarang = PermintaanbarangModel::where("prNumber", $input["prNumber"]);
		if (!$permintaanbarang->update($newInput)) {
			throw new \Exception();
		}

		$needSync = $permintaanbarang->first();
		$sync = SyncHandlersModel::where("sync.local_id", "=", $needSync->id)
			->where("sync.table_name", "=", "permintaanbarang");
		if (!$sync->update(["need_sync" => 1])) {
			throw new \Exception();
		}

		return $permintaanbarang;
	}

	public function saveStaging($staging)
	{
		$data = [];
		$totalLine = count($staging["footer"]);

		foreach ($staging["footer"] as $row) {
			$data[] =  [
				"preparer_name" 				=> $staging["header"]->requesterUsername,
				"destination_type_code" 		=> substr($row->destination_type_code, 0, 3),
				"org_id"						=> $staging["header"]->kapalId,
				"req_number_segment1"			=> $staging["header"]->prNumber,
				"apprver_name" 					=> $staging["auth"]->name . " (" . $staging["auth"]->username . ")",
				"voyage_call"					=> $staging["header"]->voyageKode,
				"interface_source_code"			=> "BEGINNING BALANCE",
				"authorization_status"			=> "APPROVED",
				"document_type_code"			=> "PURCHASE",
				"source_type_code"				=> "VENDOR",

				"item_id"						=> $row->itemId,
				"item_segment1"					=> $row->namaItem,
				"need_by_date" 					=> $row->needBy,
				"quantity" 						=> $row->quantity,

				"creation_date"					=> date("Y-m-d H:i:s"),
				// "subinventory"					=> $staging["header"]->namaLokasi,
				"header_attribute14"            => $staging["header"]->requesterJabatan,
				"header_attribute10"            => $row->qtyRob,
				"header_attribute9"            	=> $row->portBunker,
				"total_line"					=> $totalLine
			];
		}

		foreach ($data as $dat) {
			$stagingModel = new StgpelniprintModel();
			$stagingModel->fill($dat);
			if (!$stagingModel->save()) {
				throw new \Exception();
			}
		}
	}
}
